from algosdk import mnemonic, account, encoding
from algosdk.future import transaction
from algosdk.future.transaction import LogicSig, LogicSigTransaction, LogicSigAccount
from algosdk.v2client import algod, indexer
from algosdk import logic
import base64
import time

import constants

def SetupClient(network):

    if(network=="sandbox"):
        # Local sandbox node 
        algod_address = "http://localhost:4001"
        algod_token = "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"

    elif(network=="purestake"):
        # Purestake conn
        algod_address = "https://mainnet-algorand.api.purestake.io/ps2"
        algod_token = "iG4m46pAcU5ws8WYhgYPu1rywUbfYT2DaAfSs9Tv"
        headers = {
        "X-API-Key": algod_token,
        }
    
    else:
        raise ValueError

    algod_client=algod.AlgodClient(algod_token, algod_address, headers=headers)
    return algod_client

def SetupIndexer(network):
    if(network=="purestake"):
        algod_address = "https://mainnet-algorand.api.purestake.io/idx2"
        headers = {
            'X-API-key' : 'iG4m46pAcU5ws8WYhgYPu1rywUbfYT2DaAfSs9Tv',
        }
        algod_indexer=indexer.IndexerClient("", algod_address, headers)
    
    return algod_indexer

def compile_program(algod_client, source_code) :
    compile_response = algod_client.compile(source_code.decode('utf-8'))
    return base64.b64decode(compile_response['result'])    